#include "mem_func.h"
#include "sem_func.h"

int main(int argc, char const *argv[])
{
    const int id_sem=atoi(argv[1]);
    const int mem_id=atoi(argv[2]);

    //char buf[BUF_SIZE];

    const int file2=open(argv[3], O_WRONLY|O_CREAT, 0644);
    if(file2==-1)
    {
        perror("Blad funkcji open() - proc. konsumenta\n");
        exit(9);
    }

    Towar *bufor;
    bufor=(Towar*) memAtt(mem_id, O_RDONLY);

    char read;
    bufor->begin=FULL;  //0
    bufor->end=FULL;    //0

    //setValue(id_sem, SEM1, VAL);

    //int bytes_read=0;
    //int bytes_written=0;

    int counter=-1;

    while(1)
    {
        ++counter;
        if(counter==EMPTY)  //50
        {
            sleep(1);
            counter=FULL;   //0
        }

        setValue(id_sem, SEM1, (FULL+counter));
        down(id_sem, SEM1);
        read=bufor->share[bufor->begin];

        printf("Konsument:\n");
        printf("%c"-'\0', read);
        printf("\n");

        if(read=='~')
        {
            ++bufor->begin;
            if(bufor->begin==EMPTY) //50
            {
                bufor->begin=FULL;  //0
            }
            down(id_sem, SEM0);
        }


        if(write(file2, &read, (sizeof(read)))==-1)
        {
            perror("Blad zapisu do pliku\n");
            exit(10);
        }

        ++bufor->begin;
        if(bufor->begin==50)
        {
            bufor->begin=0;
        }
        up(id_sem, SEM1);
    }

    if(close(file2)==-1)
    {
        perror("Blad funkcji close() - proces konsumenta\n");
        exit(11);
    }

    delAtt(bufor);

    return 0;
}
