#include "mem_func.h"
#include "sem_func.h"

int main(int argc, char const *argv[])
{
    const int id_sem=atoi(argv[1]);
    const int mem_id=atoi(argv[2]);

    char buf[BUF_SIZE];

    const int file1=open(argv[3], O_RDONLY, 0644);
    if(file1==-1)
    {
        perror("Blad funkcji open() - proc. producenta\n");
        exit(9);
    }

    Towar *bufor;
    bufor=(Towar*) memAtt(mem_id, O_WRONLY);

    /*bufor[0].begin=0;
    bufor[0].end=0;*/

    //setValue(id_sem, SEM0, VAL);

    //int bytes_read=0;
    //int bytes_written=0;

    bufor->begin=FULL;  //0
    bufor->end=FULL;    //0
    int counter=-1;

    while(read(file1, buf, sizeof(buf)))
    {
        ++counter;
        if(counter==EMPTY)  //50
        {
            sleep(1);
            counter=FULL;   //0
        }

        setValue(id_sem, SEM0, (EMPTY-counter));
        for(int i=0; i<(strlen(buf)+1); ++i)
        {
            down(id_sem, SEM0);
            bufor->share[bufor->end]=buf[i];
            ++bufor->end;
            printf("Producent:\n");
            printf("%c\n", buf[i]);

            if(bufor->end==EMPTY)   //50
            {
            bufor->end=FULL;        //0
            }
            up(id_sem, SEM1);
        }

    }

    down(id_sem, SEM0);
    bufor->share[bufor->end]='~';
    up(id_sem, SEM1);

    if(close(file1)==-1)
    {
        perror("Blad funkcji close() - proces producenta\n");
        exit(11);
    }
    delAtt(bufor);

    return 0;
}
